Imports System.ComponentModel.DataAnnotations

Namespace CommonData
    'no ID because it's a value object
    'EF will recognized this as a complex type
    'some methods borrowed from Vaughn Vernon IDDD.NET sample
    Public Class FullName
        Inherits ValueObject(Of FullName)
        Public Sub New(ByVal firstName As String, ByVal lastName As String)
            Me.FirstName = firstName
            Me.LastName = lastName
        End Sub

        Public Sub New(ByVal fullName As FullName)
            Me.New(fullName.FirstName, fullName.LastName)
        End Sub

        Private PrivateFirstName As String
        Public Property FirstName As String
            Get
                Return PrivateFirstName
            End Get
            Private Set(ByVal value As String)
                PrivateFirstName = value
            End Set
        End Property

        Private PrivateLastName As String
        Public Property LastName As String
            Get
                Return PrivateLastName
            End Get
            Private Set(ByVal value As String)
                PrivateLastName = value
            End Set
        End Property

        Public Function AsFormattedName() As String
            Return Me.FirstName & " " & Me.LastName
        End Function

        Public Function WithChangedFirstName(ByVal firstName As String) As FullName
            Return New FullName(firstName, Me.LastName)
        End Function

        Public Function WithChangedLastName(ByVal lastName As String) As FullName
            Return New FullName(Me.FirstName, lastName)
        End Function
        Public Overrides Function ToString() As String
            Return "FullName [firstName=" & FirstName & ", lastName=" & LastName & "]"
        End Function
    End Class
End Namespace