﻿Imports System.Data.Entity
Imports CommonData
Imports DataLayer.Mappings
Imports SalesDomain
Namespace DataLayer.Sales
    Public Class SalesContext
        Inherits DbContext

        Public Property Customers As DbSet(Of Customer)
        Public Property Orders As DbSet(Of Order)
        Public Property LineItems As DbSet(Of LineItem)
        Public Property Products As DbSet(Of Product)
        Public Property Payments As DbSet(Of Payment)
        Public Property Categories As DbSet(Of Category)
        Public Property Promotions As DbSet(Of Promotion)

        Protected Overrides Sub OnModelCreating(ByVal modelBuilder As DbModelBuilder)
            modelBuilder.Configurations.Add(New LineItemMap)
            modelBuilder.Entity(Of Identity)().ToTable("Identities")
            modelBuilder.Entity(Of Contact)().ToTable("Contacts")
            modelBuilder.Entity(Of Customer)().ToTable("Customers")
            modelBuilder.Entity(Of Order)().Ignore(Function(o) o.LineItems)

        End Sub
        Public Overrides Function SaveChanges() As Integer

            Return MyBase.SaveChanges
        End Function
    End Class


End Namespace
