Imports SalesDomain

Namespace DataLayer.Sales
  Public Class SimpleOrderRepository
	Private ReadOnly _context As SalesContext
        Private ReadOnly _newOrders As New List(Of Order)
	Public Sub New()

            _context = New SalesContext
	End Sub

	Public Sub UpdateLineItemsForExistingOrder(ByVal order As Order)
	  'until I've implemented local change tracking, assume existing
	  'objects are modified. Deleted unaccounted for

	 For Each item In order.LineItems
		If item.LineItemId > 0 Then
		  _context.Entry(item).State = EntityState.Modified
		Else
		  _context.Entry(item).State = EntityState.Added
		End If
	 Next item
	End Sub

	Public Sub AddNewOrderGraph(ByVal order As Order)
	  _context.Orders.Add(order)
	  _newOrders.Add(order)
	End Sub


	Public Sub Save()

	  _context.SaveChanges()
	  'if there's a new order with line items,
	  'that order just got save,but not the line items
	  'now we'll apply the order's new db assigned key value
	  'to those items and then savechanges again
	  'this is how to get around a dependency on db assigned PK values
	  'Guids are a LOT simpler though
	  For Each order In _newOrders
		For Each item In order.LineItems
		  item.SetOrderIdentity(order.OrderId)
		Next item
	  Next order

	  _context.SaveChanges()

	End Sub
  End Class
End Namespace