Imports CommonData

Namespace SalesDomain
Public Class Customer
	Inherits Contact
  Public Sub New(ByVal firstName As String, ByVal lastName As String, ByVal email As String)
	FullName = New FullName(firstName, lastName)
	EmailAddress = email
	Status = CustomerStatus.Silver
  End Sub

  Public Sub ChangeCustomerStatus(ByVal status As CustomerStatus)
	If status=Me.Status Then
                Exit Sub
	End If
		Me.Status=status

  End Sub

  Public Sub CopyBillingAddressToShippingAddress()
	ShippingAddress = New Address(BillingAddress.Street1, BillingAddress.Street2, BillingAddress.City, BillingAddress.Region, BillingAddress.Country, BillingAddress.PostalCode)
  End Sub

  Public Sub CreateNewShippingAddress(ByVal street1 As String, ByVal street2 As String, ByVal city As String, ByVal region As String, ByVal country As String, ByVal postalCode As String)
	BillingAddress = New Address(street1,street2, city,region, country,postalCode)
  End Sub

  Public Sub CreateBillingInformation(ByVal street1 As String, ByVal street2 As String, ByVal city As String, ByVal region As String, ByVal country As String, ByVal postalCode As String, ByVal creditcardNumber As String, ByVal bankName As String)
	BillingAddress = New Address(street1,street2, city,region,country,postalCode)
	CreditCard = New CustomerCreditCard(bankName, creditcardNumber)
  End Sub

  Public Sub SetCustomerContactDetails(ByVal email As String, ByVal phone As String, ByVal companyName As String)
	EmailAddress = email
	Me.Phone = phone
	Me.CompanyName = companyName

  End Sub


        Private PrivateSalesPersonId As String
        Public Property SalesPersonId As String
            Get
                Return PrivateSalesPersonId
            End Get
            Private Set(ByVal value As String)
                PrivateSalesPersonId = value
            End Set
        End Property
        Private PrivateStatus As CustomerStatus
        Public Property Status As CustomerStatus
            Get
                Return PrivateStatus
            End Get
            Private Set(ByVal value As CustomerStatus)
                PrivateStatus = value
            End Set
        End Property
        Private PrivateShippingAddress As Address
        Public Property ShippingAddress As Address
            Get
                Return PrivateShippingAddress
            End Get
            Private Set(ByVal value As Address)
                PrivateShippingAddress = value
            End Set
        End Property
        Private PrivateBillingAddress As Address
        Public Property BillingAddress As Address
            Get
                Return PrivateBillingAddress
            End Get
            Private Set(ByVal value As Address)
                PrivateBillingAddress = value
            End Set
        End Property
        Private PrivateCreditCard As CustomerCreditCard
        Public Property CreditCard As CustomerCreditCard
            Get
                Return PrivateCreditCard
            End Get
            Private Set(ByVal value As CustomerCreditCard)
                PrivateCreditCard = value
            End Set
        End Property

End Class

  Public Enum CustomerStatus
	Silver = 1
	Gold = 2
	Platinum = 3
  End Enum
End Namespace





