﻿Imports System.Data.Entity
Imports DataLayer.Sales
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports SalesDomain
Imports System.Linq

Namespace SalesDomainTests
  <TestClass>
  Public Class UnitTest1

	<TestMethod, TestCategory("UnitTest")>
	Public Sub SilverCustomerPlusPromoDiscountEqualToPromoDiscount()

	  Dim cust = New CustomerForOrderTransferDTO With {.CustomerId = 1, .Status = CustomerStatus.Silver, .ShippingAddress = New Address("1 Main", Nothing, "Las Vegas", "NV", "US", "11111")}
            Dim order = SalesDomain.Order.CreateOrder(cust)
	  order.SetOrderDetails(False, "1234", "hurry!", New Promotion With {.Discount =.05, .StartDate = Date.Now})
	  Assert.AreEqual(.05, order.Discount)
	End Sub
	<TestMethod, TestCategory("UnitTest")>
	Public Sub GoldCustomerPlusPromoDiscountEqualToGoldPlusPromoDiscount()
	  Dim cust = New CustomerForOrderTransferDTO With {.CustomerId = 1, .Status = CustomerStatus.Gold, .ShippingAddress = New Address("1 Main", Nothing, "Las Vegas", "NV", "US", "11111")}

            Dim order = SalesDomain.Order.CreateOrder(cust)
	  order.SetOrderDetails(False, "1234", "hurry!", New Promotion With {.Discount =.05, .StartDate = Date.Now})
	  Assert.AreEqual(.1, order.Discount)
	End Sub



 <TestMethod, TestCategory("IntegrationTest")>
 Public Sub SaveNewLineItemForOrderInDatabase()

	  Database.SetInitializer(New SalesContextSeedInitilializer)

   Dim order As Order
   Dim product As Product
            Using context = New DataLayer.Sales.SalesContext
                order = context.Orders.FirstOrDefault
                product = context.Products.FirstOrDefault
            End Using
   order.CreateLineItem(product, 2)
            Dim repo = New SimpleOrderRepository
   repo.UpdateLineItemsForExistingOrder(order)
   repo.Save()

   Assert.Inconclusive("Check Database and Profiler for results")
 End Sub

 <TestMethod, TestCategory("IntegrationTest")>
 Public Sub SaveNewLineItemForNewOrderInDatabase()
            Database.SetInitializer(New SalesContextSeedInitilializer)

   Dim customer = New CustomerForOrderTransferDTO With {.CustomerId =1, .ShippingAddress = New Address("1 main",Nothing,"newcity","NY","US","12121")}
            Dim order = SalesDomain.Order.CreateOrder(customer)
   Dim product As Product
            Using context = New DataLayer.Sales.SalesContext
                product = context.Products.FirstOrDefault
            End Using
   order.CreateLineItem(product, 2)
            Dim repo = New SimpleOrderRepository
   repo.AddNewOrderGraph(order)
   repo.Save()

   Assert.Inconclusive("Check Database and Profiler for results. The interesting info is what the inserts look like")
 End Sub
  End Class
End Namespace
